//
//  $Id: ResourceDatabase.cc,v 1.1 2000/06/04 00:51:06 sergey Exp $
//

#include <Pilot.h>
#include "ResourceDatabase.h"
#include "Record.h"
#include "DbError.h"
#include "Util/Assert.h"


namespace DB
{
    // operations

    int ResourceDatabase::resourceCount() const
    {
        assert(isOpened());
        return DmNumResources(openRef());
    }

    int ResourceDatabase::findResource(long resourceType, int resourceID) const
    {
        assert(isOpened());
        return DmFindResource(openRef(), resourceType, resourceID, 0);
    }

    bool ResourceDatabase::readResource(int index, Record& resource) const
    {
        assert(isOpened());

        VoidHand resourceHandle = DmGetResourceIndex(openRef(), index);
        if (resourceHandle == 0)
        {
            DbError::readRecordError(__FILE__, __LINE__, DmGetLastErr());
            return false;
        }

        return resource.restore(index, resourceHandle);
    }

    bool ResourceDatabase::readResource(long resourceType, int resourceID, Record& resource) const
    {
        return readResource(findResource(resourceType, resourceID), resource);
    }
}
// namespace DB
